<?php
include 'inc/config.php';
include 'inc/functions.php';
include 'inc/session.php';

if (empty($user['login']) and empty($user['password']))
{
    header('Location:' . $base_url . 'logout');
    exit;
}

session_write_close();

try
{

    if ($do == 'bots_links')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        $id = intval($id);

        if (isset($id))
        {

            if($id == 0){
            $stmt = $pdo->prepare("SELECT * FROM bots WHERE project_id=:project_id");
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->execute();
            $result = $stmt->fetchAll(PDO::FETCH_ASSOC); 
            } else {
            $stmt = $pdo->prepare("SELECT * FROM bots WHERE project_id=:project_id AND list_id=:list_id");
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->bindParam(':list_id', $id);
            $stmt->execute();
            $result = $stmt->fetchAll(PDO::FETCH_ASSOC);
            }


            if(count($result) == 0){
                throw new Exception("Нет ни одного бота", 1);
            }

            // var_dump($result);
            // exit;

            $links_nus = [];
            $links_us = [];
            $links_tus = [];
            $links_tuss = [];
            $links_spintax = [];

            foreach ($result as $key => $value) {
                $links_nus[] = 'https://'.$value['username'].'.t.me';
                $links_us[] = '@'.$value['username'];
                $links_tus[] = 'https://t.me/'.$value['username'];
                $links_tuss[] = 'https://t.me/'.$value['username'].'?start='.rand(100000,999999);
                $links_spintax[] = 'https://t.me/'.$value['username'].'?start='.rand(100000,999999);
            }

            $links_us = implode("\n", $links_us);
            $links_nus = implode("\n", $links_nus);
            $links_tus = implode("\n", $links_tus);
            $links_tuss = implode("\n", $links_tuss);
            $links_spintax = '{'.implode('|', $links_spintax).'}';

            $response_array['status'] = true;
            $response_array['result'][0] = $links_us;
            $response_array['result'][1] = $links_tus;
            $response_array['result'][2] = $links_tuss;
            $response_array['result'][3] = $links_spintax;
            $response_array['result'][4] = $links_nus;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'save_project')
    {

        if (isset($_POST['name']))
        {
            $name = $_POST['name'];
            if ($name == '')
            {
                unset($name);
            }
        }
        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        $name = htmlspecialchars(strip_tags($name));
        $id = intval($id);

        if (isset($name) && isset($id))
        {

            if (editProject($id, 'name', $name))
            {

                $response_array['status'] = true;

                header('Content-type: application/json');
                echo json_encode($response_array);

            }

        }
        else
        {

            throw new Exception("Не удалось сохранить!", 1);

        }

    }


if($do == 'refresh_bots'){

$datetime = date('Y-m-d H:i');

$success = 0;
$nosuccess = 0;

$stmt = $pdo->prepare("SELECT * FROM bots WHERE project_id=:project_id");
$stmt->bindParam(':project_id', $project['id']);
$stmt->execute();
$result = $stmt->fetchAll(PDO::FETCH_ASSOC);

foreach ($result as $key => $row) {

$notify = getNotify($row['project_id']);

if(!empty($notify)){
$access_token_notify = $notify['token'];
$api_notify = 'https://api.telegram.org/bot'.$access_token_notify;
}

$result = file_get_contents('https://api.telegram.org/bot'.$row['token'].'/getMe');

$res_bot = json_decode($result, true);

if(!empty($res_bot['result']['id'])){

$status = 0;
$success++;

} else {

$status = 2;
$nosuccess++;

// $text_error[0] = str_replace('{username_bot}',$row['username'],$text_error[0]);

// $notify_users = explode(',',$notify['users_ids']);

// foreach ($notify_users as $key => $value) {

// sendMessage('api_notify',$value,$text_error[0],false,false);

// }

}

$id = $row['id'];

if(isset($id) && isset($status)){

// echo $status."\r\n";

$res_upd = $pdo->prepare("UPDATE bots SET status=:status WHERE id=:id");
$res_upd->bindParam(':status', $status);
$res_upd->bindParam(':id', $id);
$res_upd->execute();

}

}

$response_array['status'] = true;
$response_array['result']['active'] = $success;
$response_array['result']['banned'] = $nosuccess;

header('Content-type: application/json');
echo json_encode($response_array);

}

    if ($do == 'save_sender')
    {

        if (isset($_POST['data']))
        {
            $data = $_POST['data'];
            if ($data == '')
            {
                unset($data);
            }
        }

        if (isset($data['message']) && isset($data['time']))
        {

            $stmt = $pdo->prepare("UPDATE senders SET message=:message, image=:image, time=:time, name_button=:name_button, url_button=:url_button WHERE id=:id");
            $stmt->bindParam(':message', $data['message']);
            $stmt->bindParam(':image', $data['image']);
            $stmt->bindParam(':time', $data['time']);
            $stmt->bindParam(':name_button', $data['name_button']);
            $stmt->bindParam(':url_button', $data['url_button']);
            $stmt->bindParam(':id', $data['id']);
            $stmt->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }
        else
        {
            throw new Exception("Не удалось сохранить!", 1);
        }

    }

    if ($do == 'new_auto_sender')
    {

        if (isset($_POST['data']))
        {
            $data = $_POST['data'];
            if ($data == '')
            {
                unset($data);
            }
        }

        $date_created = date('Y-m-d H:i:s');

        if (isset($data['message']) && isset($data['time']))
        {

            $stmt = $pdo->prepare('INSERT INTO senders (project_id,message,name_button,url_button,image,time,date_created) VALUES (:project_id,:message,:name_button,:url_button,:image,:time,:date_created)');
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->bindParam(':message', $data['message']);
            $stmt->bindParam(':name_button', $data['name_button']);
            $stmt->bindParam(':url_button', $data['url_button']);
            $stmt->bindParam(':image', $data['image']);
            $stmt->bindParam(':time', $data['time']);
            $stmt->bindParam(':date_created', $date_created);
            $stmt->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }
        else
        {
            throw new Exception("Не удалось создать рассылку!", 1);
        }

    }

    if ($do == 'save_notify')
    {

        if (isset($_POST['users_ids']))
        {
            $users_ids = $_POST['users_ids'];
            if ($users_ids == '')
            {
                unset($users_ids);
            }
        }
        if (isset($_POST['token']))
        {
            $token = $_POST['token'];
            if ($token == '')
            {
                unset($token);
            }
        }
        if (isset($_POST['new_members']))
        {
            $new_members = $_POST['new_members'];
            if ($new_members == '')
            {
                unset($new_members);
            }
        }
        if (isset($_POST['new_del_bots']))
        {
            $new_del_bots = $_POST['new_del_bots'];
            if ($new_del_bots == '')
            {
                unset($new_del_bots);
            }
        }
        if (isset($_POST['hash']))
        {
            $hash = $_POST['hash'];
            if ($hash == '')
            {
                unset($hash);
            }
        }   

        $stmt = $pdo->prepare("SELECT * FROM projects WHERE hash=:hash");
        $stmt->bindParam(':hash', $hash);
        $stmt->execute();
        $project = $stmt->fetch(PDO::FETCH_ASSOC);

        $project_id = $project['id'];

        if (isset($token) && isset($project_id))
        {

            if (empty($new_members))
            {
                $new_members = 0;
            }
            if (empty($new_del_bots))
            {
                $new_del_bots = 0;
            }
            if (empty($new_acc))
            {
                $new_acc = 0;
            }

            $stmt = $pdo->prepare("SELECT * FROM notify WHERE project_id=:project_id");
            $stmt->bindParam(':project_id', $project_id);
            $stmt->execute();
            $notify = $stmt->fetch(PDO::FETCH_ASSOC);

            if (empty($notify['id']))
            {

                $stmt = $pdo->prepare('INSERT INTO notify (project_id,users_ids,new_members,new_del_bots,token) VALUES (:project_id,:users_ids,:new_members,:new_del_bots,:token)');
                $stmt->bindParam(':project_id', $project_id);
                $stmt->bindParam(':users_ids', $users_ids);
                $stmt->bindParam(':new_members', $new_members);
                $stmt->bindParam(':new_del_bots', $new_del_bots);
                $stmt->bindParam(':token', $token);
                if ($stmt->execute())
                {

                    $response_array['status'] = true;

                    header('Content-type: application/json');
                    echo json_encode($response_array);

                }

            }
            else
            {

                $stmt = $pdo->prepare("UPDATE notify SET users_ids=:users_ids, token=:token, new_members=:new_members, new_del_bots=:new_del_bots WHERE project_id=:project_id");
                $stmt->bindParam(':users_ids', $users_ids);
                $stmt->bindParam(':token', $token);
                $stmt->bindParam(':new_members', $new_members);
                $stmt->bindParam(':new_del_bots', $new_del_bots);
                $stmt->bindParam(':project_id', $project_id);
                if ($stmt->execute())
                {

                    $response_array['status'] = true;

                    header('Content-type: application/json');
                    echo json_encode($response_array);

                }

            }

        }

    }

    if ($do == 'bots_refresh')
    {

        $bots = getBots($project['id']);

        foreach ($bots as $key => $value)
        {
            if ($value['status'] == 2)
            {
                editBot($value['id'], 'status', 0);
            }
        }

        $response_array['status'] = true;

        header('Content-type: application/json');
        echo json_encode($response_array);

    }

    if ($do == 'new_sender')
    {

        if (isset($_POST['data']))
        {
            $data = $_POST['data'];
            if ($data == '')
            {
                unset($data);
            }
        }

        $date_created = date('Y-m-d H:i:s');

        $success_count = 0;

        if ($data['bot_id'] == 'all')
        {

            $stmt = $pdo->prepare("SELECT * FROM bots WHERE project_id=:project_id");
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->execute();
            $bots = $stmt->fetchAll(PDO::FETCH_ASSOC);

            foreach ($bots as $key => $bot)
            {

                $stmt = $pdo->prepare("SELECT * FROM users WHERE bot_id=:bot_id ORDER BY date_join DESC");
                $stmt->bindParam(':bot_id', $bot['id']);
                $stmt->execute();
                $users = $stmt->fetchAll(PDO::FETCH_ASSOC);

                if ($data['name_button'] != '' and $data['url_button'] != '')
                {

                    $inline_keyboard[] = array(
                        "text" => $data['name_button'],
                        "url" => $data['url_button']
                    );

                    $keyboard = array(
                        "inline_keyboard" => array_chunk($inline_keyboard, 1)
                    );
                    $replyMarkup = json_encode($keyboard);

                    $param_button = '&reply_markup=' . $replyMarkup;

                }
                else
                {

                    $param_button = '';

                }

                foreach ($users as $key => $user)
                {

                    if (empty($data['image']))
                    {

                        $res = file_get_contents('https://api.telegram.org/bot' . $bot['token'] . '/sendMessage?chat_id=' . $user['chat_id'] . '&text=' . urlencode($data['message']) . '&parse_mode=HTML' . $param_button);
                        $decode = json_decode($res, true);

                        if ($decode['ok'] == true)
                        {
                            $success_count++;
                            editUser($user['chat_id'], $bot['id'], 'status', 1);
                        }

                        if ($decode['ok'] == false)
                        {
                            editUser($user['chat_id'], $bot['id'], 'status', 2);
                        }

                    }
                    else
                    {

                        $ext = explode('.', $data['image']);

                        if ($ext[1] == 'gif')
                        {

                            $res = file_get_contents('https://api.telegram.org/bot' . $bot['token'] . '/sendAnimation?chat_id=' . $user['chat_id'] . '&animation=' . $base_url . $data['image'] . '&caption=' . urlencode($data['message']) . '&parse_mode=HTML' . $param_button);

                        }
                        else
                        {

                            $res = file_get_contents('https://api.telegram.org/bot' . $bot['token'] . '/sendPhoto?chat_id=' . $user['chat_id'] . '&photo=' . $base_url . $data['image'] . '&caption=' . urlencode($data['message']) . '&parse_mode=HTML' . $param_button);
                        }

                        $decode = json_decode($res, true);

                        if ($decode['ok'] == true)
                        {
                            $success_count++;
                            editUser($user['chat_id'], $bot['id'], 'status', 1);
                        }

                        if ($decode['ok'] == false)
                        {
                            editUser($user['chat_id'], $bot['id'], 'status', 2);
                        }
                    }
                }

            }

        }

        if(strpos($data['bot_id'],'list-') !== false){

            $list_id = preg_replace("/[^0-9]/", '', $data['bot_id']);

            $stmt = $pdo->prepare("SELECT * FROM bots WHERE project_id=:project_id AND list_id=:list_id");
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->bindParam(':list_id', $list_id);
            $stmt->execute();
            $bots = $stmt->fetchAll(PDO::FETCH_ASSOC);

            foreach ($bots as $key => $bot)
            {

                $stmt = $pdo->prepare("SELECT * FROM users WHERE bot_id=:bot_id ORDER BY date_join DESC");
                $stmt->bindParam(':bot_id', $bot['id']);
                $stmt->execute();
                $users = $stmt->fetchAll(PDO::FETCH_ASSOC);

                if ($data['name_button'] != '' and $data['url_button'] != '')
                {

                    $inline_keyboard[] = array(
                        "text" => $data['name_button'],
                        "url" => $data['url_button']
                    );

                    $keyboard = array(
                        "inline_keyboard" => array_chunk($inline_keyboard, 1)
                    );
                    $replyMarkup = json_encode($keyboard);

                    $param_button = '&reply_markup=' . $replyMarkup;

                }
                else
                {

                    $param_button = '';

                }

                // echo $bot['id'].'<Br>';

                foreach ($users as $key => $user)
                {

                    // echo $user['chat_id'].'<Br>';

                    if (empty($data['image']))
                    {

                        $res = file_get_contents('https://api.telegram.org/bot' . $bot['token'] . '/sendMessage?chat_id=' . $user['chat_id'] . '&text=' . urlencode($data['message']) . '&parse_mode=HTML' . $param_button);
                        $decode = json_decode($res, true);

                        if ($decode['ok'] == true)
                        {
                            $success_count++;
                            editUser($user['chat_id'], $bot['id'], 'status', 1);
                        }

                        if ($decode['ok'] == false)
                        {
                            editUser($user['chat_id'], $bot['id'], 'status', 2);
                        }

                    }
                    else
                    {

                        $ext = explode('.', $data['image']);

                        if ($ext[1] == 'gif')
                        {

                            $res = file_get_contents('https://api.telegram.org/bot' . $bot['token'] . '/sendAnimation?chat_id=' . $user['chat_id'] . '&animation=' . $base_url . $data['image'] . '&caption=' . urlencode($data['message']) . '&parse_mode=HTML' . $param_button);

                        }
                        else
                        {

                            $res = file_get_contents('https://api.telegram.org/bot' . $bot['token'] . '/sendPhoto?chat_id=' . $user['chat_id'] . '&photo=' . $base_url . $data['image'] . '&caption=' . urlencode($data['message']) . '&parse_mode=HTML' . $param_button);
                        }

                        $decode = json_decode($res, true);

                        if ($decode['ok'] == true)
                        {
                            $success_count++;
                            editUser($user['chat_id'], $bot['id'], 'status', 1);
                        }

                        if ($decode['ok'] == false)
                        {
                            editUser($user['chat_id'], $bot['id'], 'status', 2);
                        }
                    }
                }

            }

        }

        if(strpos($data['bot_id'],'bot-') !== false){

            $bot_id = preg_replace("/[^0-9]/", '', $data['bot_id']);

            $stmt = $pdo->prepare("SELECT * FROM bots WHERE id=:bot_id");
            $stmt->bindParam(':bot_id', $bot_id);
            $stmt->execute();
            $bot = $stmt->fetch(PDO::FETCH_ASSOC);

            $stmt = $pdo->prepare("SELECT * FROM users WHERE bot_id=:bot_id ORDER BY date_join DESC");
            $stmt->bindParam(':bot_id', $bot_id);
            $stmt->execute();
            $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

            if ($data['name_button'] != '' and $data['url_button'] != '')
            {

                $inline_keyboard[] = array(
                    "text" => $data['name_button'],
                    "url" => $data['url_button']
                );

                $keyboard = array(
                    "inline_keyboard" => array_chunk($inline_keyboard, 1)
                );
                $replyMarkup = json_encode($keyboard);

                $param_button = '&reply_markup=' . $replyMarkup;

            }
            else
            {

                $param_button = '';

            }

            foreach ($result as $key => $value)
            {

                if (empty($data['image']))
                {

                    $res = file_get_contents('https://api.telegram.org/bot' . $bot['token'] . '/sendMessage?chat_id=' . $value['chat_id'] . '&text=' . urlencode($data['message']) . '&parse_mode=HTML' . $param_button);
                    $decode = json_decode($res, true);

                    if ($decode['ok'] == true)
                    {
                        $success_count++;
                        editUser($value['chat_id'], $bot['id'], 'status', 1);
                    }

                    if ($decode['ok'] == false)
                    {
                        editUser($value['chat_id'], $bot['id'], 'status', 2);
                    }

                }
                else
                {

                    $ext = explode('.', $data['image']);

                    if ($ext[1] == 'gif')
                    {

                        $res = file_get_contents('https://api.telegram.org/bot' . $bot['token'] . '/sendAnimation?chat_id=' . $value['chat_id'] . '&animation=' . $base_url . $data['image'] . '&caption=' . urlencode($data['message']) . '&parse_mode=HTML' . $param_button);

                    }
                    else
                    {

                        $res = file_get_contents('https://api.telegram.org/bot' . $bot['token'] . '/sendPhoto?chat_id=' . $value['chat_id'] . '&photo=' . $base_url . $data['image'] . '&caption=' . urlencode($data['message']) . '&parse_mode=HTML' . $param_button);
                    }
                    $decode = json_decode($res, true);

                    if ($decode['ok'] == true)
                    {
                        $success_count++;
                        editUser($value['chat_id'], $bot['id'], 'status', 1);
                    }

                    if ($decode['ok'] == false)
                    {
                        editUser($value['chat_id'], $bot['id'], 'status', 2);
                    }
                }
            }
        }

        if ($success_count > 0)
        {

            $success_count_text = 'Отправлено ' . $success_count . ' ' . wordForm($success_count, array(
                'сообщение',
                'сообщения',
                'сообщений'
            ));

            $response_array['status'] = true;
            $response_array['success_count'] = $success_count_text;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'new_cabinet' and $is_admin == 1)
    {

        if (isset($_POST['data']))
        {
            $data = $_POST['data'];
            if ($data == '')
            {
                unset($data);
            }
        }

        $stmt = $pdo->prepare("SELECT * FROM users_site WHERE login=:login");
        $stmt->bindParam(':login', $data['login']);
        $stmt->execute();
        $user_check = $stmt->fetch(PDO::FETCH_ASSOC);

        if (!empty($user_check['login']))
        {
            throw new Exception("Пользователь с таким логином уже существует!", 1);
        }

        if (mb_strlen($data['login']) == 0 or ($data['login'] == ''))
        {
            throw new Exception("Вы не ввели логин!", 1);
        }

        if (mb_strlen($data['password']) == 0 or ($data['password'] == ''))
        {
            throw new Exception("Вы не ввели пароль!", 1);
        }

        $password = md5($data['password']);
        $password = strrev($password);
        $password = $password . "q6ERAHvYhq";

        $new_cabinet = addCabinet($data['login'], $password);

        $response_array['status'] = true;

        header('Content-type: application/json');
        echo json_encode($response_array);

    }

    if ($do == 'new_bots')
    {

        if (isset($_POST['token']))
        {
            $token = $_POST['token'];
            if ($token == '')
            {
                unset($token);
            }
        }
        if (isset($_POST['list_id']))
        {
            $list_id = $_POST['list_id'];
            if ($list_id == '')
            {
                unset($list_id);
            }
        }
        if (isset($_POST['temp_id']))
        {
            $temp_id = $_POST['temp_id'];
            if ($temp_id == '')
            {
                unset($temp_id);
            }
        }

        if (isset($temp_id) && isset($list_id) || $list_id == 0 && isset($token))
        {

            $token = explode("\n", $token);

            foreach ($token as $key => $value)
            {
                $value = trim($value);

                $param_token = explode(":", $value);

                $token = $param_token[0] . ':' . $param_token[1];
                $username = $param_token[2];

                $date_created = date('Y-m-d H:i:s');
                $status = 0;

                $stmt = $pdo->prepare('INSERT INTO bots (project_id,list_id,temp_id,chat_id,token,username,date_created,status) VALUES (:project_id,:list_id,:temp_id,:chat_id,:token,:username,:date_created,:status)');
                $stmt->bindParam(':project_id', $project['id']);
                $stmt->bindParam(':list_id', $list_id);
                $stmt->bindParam(':temp_id', $temp_id);
                $stmt->bindParam(':chat_id', $param_token[0]);
                $stmt->bindParam(':token', $token);
                $stmt->bindParam(':username', $username);
                $stmt->bindParam(':date_created', $date_created);
                $stmt->bindParam(':status', $status);
                $stmt->execute();

                $res_get = file_get_contents('https://api.telegram.org/bot' . $token . '/setWebhook?drop_pending_updates=true&url=' . $base_url . 'bot/index.php?id=' . $pdo->lastInsertId());
                $decode_get = json_decode($res_get, true);

            }

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'new_list')
    {

        if (isset($_POST['title']))
        {
            $title = $_POST['title'];
            if ($title == '')
            {
                unset($title);
            }
        }

        if (isset($title))
        {

            $updated_at = strtotime('NOW');
          
            $stmt = $pdo->prepare('INSERT INTO bots_list (project_id,title,updated_at) VALUES (:project_id,:title,:updated_at)');
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->bindParam(':title', $title);
            $stmt->bindParam(':updated_at', $updated_at);
            $stmt->execute();

            if($pdo->lastInsertId()){

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

           }

        }

    }

    if ($do == 'new_bot')
    {


        if(empty($_POST['token']) || $_POST['token'] == ''){
            throw new Exception("Токен не указан!", 1);
        }

        if(!isset($_POST['list_id']) || $_POST['list_id'] == ''){
            throw new Exception("Папка не указана!", 1);
        }

        if(!isset($_POST['temp_id']) || $_POST['temp_id'] == 0 || $_POST['temp_id'] == ''){
            throw new Exception("Шаблон не указан!", 1);
        }

            if (isset($_POST['token']))
            {
                $token = $_POST['token'];
                if ($token == '')
                {
                    unset($token);
                }
            }
        if (isset($_POST['list_id']))
        {
            $list_id = $_POST['list_id'];
            if ($list_id == '')
            {
                unset($list_id);
            }
        }
        if (isset($_POST['temp_id']))
        {
            $temp_id = $_POST['temp_id'];
            if ($temp_id == '')
            {
                unset($temp_id);
            }
        }

        if (isset($temp_id) && isset($list_id) || $list_id == 0 && isset($token))
        {

            if($list_id != 0){
                $list = getBotListByID($list_id);
                if(empty($list['id'])){
                    throw new Exception('Папка не найдена');
                }
            }

            $temp = getTempByID($temp_id);
            if(empty($temp['id'])){
                throw new Exception('Шаблон не найден');
            }


            $res = file_get_contents('https://api.telegram.org/bot' . $token . '/getMe');
            $v = json_decode($res, true);

            $username = $v['result']['username'];
            $chat_id = $v['result']['id'];

            $check = getBotByChatID($chat_id);

            if(!empty($check['chat_id'])){
                throw new Exception('Такой бот уже существует');
            }

            $date_created = date('Y-m-d H:i:s');
            $status = 0;

            $stmt = $pdo->prepare('INSERT INTO bots (project_id,list_id,temp_id,chat_id,token,username,date_created,status) VALUES (:project_id,:list_id,:temp_id,:chat_id,:token,:username,:date_created,:status)');
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->bindParam(':list_id', $list_id);
            $stmt->bindParam(':temp_id', $temp_id);
            $stmt->bindParam(':chat_id', $chat_id);
            $stmt->bindParam(':token', $token);
            $stmt->bindParam(':username', $username);
            $stmt->bindParam(':date_created', $date_created);
            $stmt->bindParam(':status', $status);
            $stmt->execute();

            $id = $pdo->lastInsertId();

            $res_get = file_get_contents('https://api.telegram.org/bot' . $token . '/setWebhook?drop_pending_updates=true&url=' . $base_url . 'bot/index.php?id=' . $id);
            $decode_get = json_decode($res_get, true);

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'save_bot')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }
        if (isset($_POST['temp_id']))
        {
            $temp_id = $_POST['temp_id'];
            if ($temp_id == '')
            {
                unset($temp_id);
            }
        }
        if (isset($_POST['token']))
        {
            $token = $_POST['token'];
            if ($token == '')
            {
                unset($token);
            }
        }

        if (isset($id) && isset($temp_id) && isset($token))
        {

            $res = file_get_contents('https://api.telegram.org/bot' . $token . '/getMe');
            $v = json_decode($res, true);

            $username = $v['result']['username'];
            $chat_id = $v['result']['id'];

            $stmt = $pdo->prepare("UPDATE bots SET temp_id=:temp_id, token=:token, username=:username, chat_id=:chat_id WHERE project_id=:project_id AND id=:id");
            $stmt->execute(array(
                'project_id' => $project['id'],
                'temp_id' => $temp_id,
                'id' => intval($id) ,
                'token' => $token,
                'username' => $username,
                'chat_id' => $chat_id
            ));

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }
    }

    if ($do == 'create_template')
    {

        if (isset($_POST['data']))
        {
            $data = $_POST['data'];
            if ($data == '')
            {
                unset($data);
            }
        }

        $date_edit = date('Y-m-d H:i:s');

        $del_time = 0;

        $stmt = $pdo->prepare('INSERT INTO templates (project_id,name,del_time,date_edit) VALUES (:project_id,:name,:del_time,:date_edit)');
        $stmt->bindParam(':project_id', $project['id']);
        $stmt->bindParam(':name', $data['name']);
        $stmt->bindParam(':del_time', $del_time);
        $stmt->bindParam(':date_edit', $date_edit);
        $stmt->execute();

        $response_array['status'] = true;
        $response_array['id'] = $pdo->lastInsertId();

        header('Content-type: application/json');
        echo json_encode($response_array);

    }

    if ($do == 'create_project')
    {

        if (isset($_POST['data']))
        {
            $data = $_POST['data'];
            if ($data == '')
            {
                unset($data);
            }
        }

        $date_created = date('Y-m-d H:i:s');

        $hash = random_bytes(10);
        $hash = bin2hex($hash);

        $stmt = $pdo->prepare('INSERT INTO projects (user_id,name,hash,date_created) VALUES (:user_id,:name,:hash,:date_created)');
        $stmt->bindParam(':user_id', $user_id);
        $stmt->bindParam(':name', $data['name']);
        $stmt->bindParam(':hash', $hash);
        $stmt->bindParam(':date_created', $date_created);
        $stmt->execute();

        $response_array['status'] = true;
        $response_array['hash'] = $hash;

        header('Content-type: application/json');
        echo json_encode($response_array);

    }

    if ($do == 'get_sender')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $stmt = $pdo->prepare("SELECT * FROM senders WHERE project_id=:project_id AND id=:id");
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->bindParam(':id', $id);
            $stmt->execute();
            $sender = $stmt->fetch(PDO::FETCH_ASSOC);

            $response_array['message'] = $sender['message'];
            $response_array['time'] = $sender['time'];
            $response_array['image'] = $sender['image'];
            $response_array['name_button'] = $sender['name_button'];
            $response_array['url_button'] = $sender['url_button'];

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'save_btn')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }
        if (isset($_POST['temp_id']))
        {
            $temp_id = $_POST['temp_id'];
            if ($temp_id == '')
            {
                unset($temp_id);
            }
        }
        if (isset($_POST['name']))
        {
            $name = $_POST['name'];
            if ($name == '')
            {
                unset($name);
            }
        }
        if (isset($_POST['action']))
        {
            $action = $_POST['action'];
            if ($action == '')
            {
                unset($action);
            }
        }

        if (isset($id) && isset($name) && isset($action))
        {
            $stmt = $pdo->prepare("UPDATE buttons SET name=:name, action=:action WHERE project_id=:project_id AND temp_id=:temp_id AND id=:id");
            $stmt->execute(array(
                'project_id' => $project['id'],
                'temp_id' => $temp_id,
                'name' => $name,
                'action' => $action,
                'id' => intval($id)
            ));

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'save_text')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }
        if (isset($_POST['temp_id']))
        {
            $temp_id = $_POST['temp_id'];
            if ($temp_id == '')
            {
                unset($temp_id);
            }
        }
        if (isset($_POST['text']))
        {
            $text = $_POST['text'];
            if ($text == '')
            {
                unset($text);
            }
        }

        if (isset($id) && isset($text))
        {
            $stmt = $pdo->prepare("UPDATE answers SET text=:text WHERE project_id=:project_id AND temp_id=:temp_id AND id=:id");
            $stmt->execute(array(
                'project_id' => $project['id'],
                'temp_id' => $temp_id,
                'text' => $text,
                'id' => intval($id)
            ));

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'move_buttons')
    {

        if (isset($_POST['temp_id']))
        {
            $temp_id = $_POST['temp_id'];
            if ($temp_id == '')
            {
                unset($temp_id);
            }
        }

        if (!empty($_POST['sort']))
        {
            foreach ($_POST['sort'] as $i => $row)
            {
                $sth = $pdo->prepare("UPDATE buttons SET num=:num WHERE project_id=:project_id AND temp_id=:temp_id AND id=:id");
                $sth->execute(array(
                    'project_id' => $project['id'],
                    'temp_id' => $temp_id,
                    'num' => ++$i,
                    'id' => intval($row)
                ));
            }

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'move_answers')
    {

        if (isset($_POST['temp_id']))
        {
            $temp_id = $_POST['temp_id'];
            if ($temp_id == '')
            {
                unset($temp_id);
            }
        }

        if (!empty($_POST['sort']))
        {
            foreach ($_POST['sort'] as $i => $row)
            {
                $sth = $pdo->prepare("UPDATE answers SET num=:num WHERE project_id=:project_id AND temp_id=:temp_id AND id=:id");
                $sth->execute(array(
                    'project_id' => $project['id'],
                    'temp_id' => $temp_id,
                    'num' => ++$i,
                    'id' => intval($row)
                ));
            }

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }


    if ($do == 'move')
    {

        if (isset($_POST['list_id']))
        {
            $list_id = $_POST['list_id'];
            if ($list_id == '')
            {
                unset($list_id);
            }
        }

        if (!empty($_POST['id']))
        {
            foreach ($_POST['id'] as $i => $row)
            {
                $sth = $pdo->prepare("UPDATE bots SET list_id=:list_id WHERE project_id=:project_id AND id=:id");
                $sth->execute(array(
                    'project_id' => $project_id,
                    'list_id' => $list_id,
                    'id' => intval($row)
                ));
            }

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'del_acc')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $res_del = $pdo->prepare("DELETE FROM accounts WHERE project_id=:project_id AND id=:id");
            $res_del->bindParam(':project_id', $project['id']);
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'del_user' and $is_admin == 1)
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $res_del = $pdo->prepare("DELETE FROM users_site WHERE id=:id");
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'del_bot')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $res_del = $pdo->prepare("DELETE FROM bots WHERE project_id=:project_id AND id=:id");
            $res_del->bindParam(':project_id', $project['id']);
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $res_del = $pdo->prepare("DELETE FROM users WHERE bot_id=:bot_id");
            $res_del->bindParam(':bot_id', $id);
            $res_del->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'del_list')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $res_del = $pdo->prepare("DELETE FROM bots_list WHERE project_id=:project_id AND id=:id");
            $res_del->bindParam(':project_id', $project['id']);
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $list_id = 0;

            $stmt = $pdo->prepare("UPDATE bots SET list_id=:list_id WHERE project_id=:project_id");
            $stmt->bindParam(':list_id', $list_id);
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'del_sender')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $res_del = $pdo->prepare("DELETE FROM senders WHERE project_id=:project_id AND id=:id");
            $res_del->bindParam(':project_id', $project['id']);
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'del_template')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $res_del = $pdo->prepare("DELETE FROM templates WHERE project_id=:project_id AND id=:id");
            $res_del->bindParam(':project_id', $project['id']);
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $res_del = $pdo->prepare("DELETE FROM answers WHERE project_id=:project_id AND temp_id=:temp_id");
            $res_del->bindParam(':project_id', $project['id']);
            $res_del->bindParam(':temp_id', $id);
            $res_del->execute();

            $res_del = $pdo->prepare("DELETE FROM buttons WHERE project_id=:project_id AND temp_id=:temp_id");
            $res_del->bindParam(':project_id', $project['id']);
            $res_del->bindParam(':temp_id', $id);
            $res_del->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'del_project')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $res_del = $pdo->prepare("DELETE FROM projects WHERE id=:id");
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $res_del = $pdo->prepare("DELETE FROM buttons WHERE project_id=:id");
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $res_del = $pdo->prepare("DELETE FROM bots WHERE project_id=:id");
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $res_del = $pdo->prepare("DELETE FROM answers WHERE project_id=:id");
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $res_del = $pdo->prepare("DELETE FROM senders WHERE project_id=:id");
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'del_answer')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $res_del = $pdo->prepare("DELETE FROM answers WHERE id=:id");
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $res_del = $pdo->prepare("DELETE FROM buttons WHERE answer_id=:id");
            $res_del->bindParam(':id', $id);
            $res_del->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }

    }

    if ($do == 'stop_bot')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $stmt = $pdo->prepare("SELECT * FROM bots WHERE id=:id");
            $stmt->bindParam(':id', $id);
            $stmt->execute();
            $bot = $stmt->fetch(PDO::FETCH_ASSOC);

            $bot_id = $bot['id'];
            $bot_token = $bot['token'];

            $res_get = file_get_contents('https://api.telegram.org/bot' . $bot_token . '/deleteWebhook?drop_pending_updates=true&url=' . $base_url . 'bot/index.php?id=' . $bot_id);
            $decode_get = json_decode($res_get, true);

            if ($decode_get['result'] == true)
            {

                $status = 1;

                $stmt = $pdo->prepare("UPDATE bots SET status=:status WHERE project_id=:project_id AND id=:id");
                $stmt->execute(array(
                    'project_id' => $project['id'],
                    'status' => $status,
                    'id' => intval($id)
                ));

                $response_array['status'] = true;

                header('Content-type: application/json');
                echo json_encode($response_array);

            }
            else
            {
                throw new Exception("Не удалось остановить бот!", 1);
            }

        }

    }

    if ($do == 'start_bot')
    {

        if (isset($_POST['id']))
        {
            $id = $_POST['id'];
            if ($id == '')
            {
                unset($id);
            }
        }

        if (isset($id))
        {

            $stmt = $pdo->prepare("SELECT * FROM bots WHERE id=:id");
            $stmt->bindParam(':id', $id);
            $stmt->execute();
            $bot = $stmt->fetch(PDO::FETCH_ASSOC);

            $bot_id = $bot['id'];
            $bot_token = $bot['token'];

            $res_get = file_get_contents('https://api.telegram.org/bot' . $bot_token . '/setWebhook?drop_pending_updates=true&url=' . $base_url . 'bot/index.php?id=' . $bot_id);
            $decode_get = json_decode($res_get, true);

            if ($decode_get['result'] == true)
            {

                $status = 0;

                $stmt = $pdo->prepare("UPDATE bots SET status=:status WHERE project_id=:project_id AND id=:id");
                $stmt->execute(array(
                    'project_id' => $project['id'],
                    'status' => $status,
                    'id' => intval($id)
                ));

                $response_array['status'] = true;

                header('Content-type: application/json');
                echo json_encode($response_array);

            }
            else
            {
                throw new Exception("Не удалось запустить бота!", 1);
            }

        }

    }

    if ($do == 'del_time'){

    	if (isset($_POST['temp_id']))
        {
            $id = intval($_POST['temp_id']);
            if ($id == '')
            {
                unset($id);
            }
        }


    	if (isset($_POST['del_time']))
        {
            $del_time = $_POST['del_time'];
            if ($del_time == '')
            {
                unset($del_time);
            }
        }

        $stmt = $pdo->prepare("UPDATE templates SET del_time=:del_time WHERE project_id=:project_id AND id=:id");
        $stmt->bindParam(':del_time', $del_time);
        $stmt->bindParam(':project_id', $project['id']);
        $stmt->bindParam(':id', $id);
        $stmt->execute();

        $response_array['status'] = true;

        header('Content-type: application/json');
        echo json_encode($response_array);
    }

    if ($do == 'new_temp')
    {

        if (isset($_POST['data']))
        {
            $data = $_POST['data'];
            if ($data == '')
            {
                unset($data);
            }
        }

        $date_edit = date('Y-m-d H:i:s');

        $stmt = $pdo->prepare("UPDATE templates SET date_edit=:date_edit WHERE project_id=:project_id AND id=:id");
        $stmt->bindParam(':date_edit', $date_edit);
        $stmt->bindParam(':project_id', $project['id']);
        $stmt->bindParam(':date_edit', $date_edit);
        $stmt->bindParam(':id', $data['temp_id']);
        $stmt->execute();

        $res_num_ans = $pdo->prepare("SELECT * FROM answers WHERE project_id=:project_id AND temp_id=:temp_id ORDER BY num DESC LIMIT 1");
        $res_num_ans->bindParam(':project_id', $project['id']);
        $res_num_ans->bindParam(':temp_id', $data['temp_id']);
        $res_num_ans->execute();
        $num_ans = $res_num_ans->fetch(PDO::FETCH_ASSOC);

        $count = $res_num_ans->rowCount();

        if ($count == 0)
        {
            $num = 0;
        }
        else
        {
            $num = ++$num_ans['num'];
        }

        // Ответ
        if ($data['text'] != '' && isset($num))
        {

            if ($data['name_button1'] != '' && $data['act_button1'] != '')
            {

                $type = 1;

            }
            else
            {

                $type = 0;

            }

            if (empty($data['image']))
            {
                $image = '';
            }
            else
            {
                $image = $data['image'];
            }

            if ($data['sleep'] == '')
            {
                $sleep = 0;
            }
            else
            {
                $sleep = $data['sleep'];
            }

            if (empty($data['del']))
            {
                $param_del = 0;
            }
            else
            {
                $param_del = 1;
            }

            if (empty($data['upd']))
            {

                $param_upd = 0;
                $btn_upd = '';

            }
            else
            {

                $param_upd = 1;
                $btn_upd = $data['name_button_upd'] . '::' . $data['act_button_upd'];

            }

            if (strpos($data['text'], '[captcha|') !== false)
            {
                $param_captcha = 1;
                $type = 0;
            }
            else
            {
                $param_captcha = 0;
            }

            if (strpos($data['text'], '[ref]') !== false)
            {

                $callback = 'ref';
                $type = 3;

            }
            else
            {

                $callback = '';

            }

            $sub_channel = '';

            // if ($data['sub_channel_id'] != '' and $data['sub_channel_link'] != '')
            // {
            //     $sub_channel = $data['sub_channel_id'] . '::' . $data['sub_channel_link'];
            // }

            $stmt = $pdo->prepare('INSERT INTO answers (project_id,temp_id,text,photo,sleep,callback,del,num,type,captcha,btn_upd,sub_channel) VALUES (:project_id,:temp_id,:text,:photo,:sleep,:callback,:del,:num,:type,:captcha,:btn_upd,:sub_channel)');
            $stmt->bindParam(':project_id', $project['id']);
            $stmt->bindParam(':temp_id', $data['temp_id']);
            $stmt->bindParam(':text', $data['text']);
            $stmt->bindParam(':photo', $image);
            $stmt->bindParam(':sleep', $sleep);
            $stmt->bindParam(':callback', $callback);
            $stmt->bindParam(':del', $param_del);
            $stmt->bindParam(':captcha', $param_captcha);
            $stmt->bindParam(':btn_upd', $btn_upd);
            $stmt->bindParam(':sub_channel', $sub_channel);
            $stmt->bindParam(':type', $type);
            $stmt->bindParam(':num', $num);
            $stmt->execute();

            $response_array['status'] = true;

            header('Content-type: application/json');
            echo json_encode($response_array);

        }
        else
        {
            throw new Exception("Не удалось создать ответ!", 1);
        }
        // Ответ
        $answer_id = $pdo->lastInsertId();

        // Кнопка 1
        if (!empty($data['name_button1']) && !empty($data['act_button1']) and $data['name_button1'] != '' && $data['act_button1'] != '')
        {

            $num = 1;
            include 'inc/blocks/block_add_button.php';

        }
        // Кнопка 1
        

        // Кнопка 2
        if (!empty($data['name_button2']) && !empty($data['act_button2']) and $data['name_button2'] != '' && $data['act_button2'] != '')
        {

            $num = 2;
            include 'inc/blocks/block_add_button.php';

        }
        // Кнопка 2
        

        // Кнопка 3
        if (!empty($data['name_button3']) && !empty($data['act_button3']) and $data['name_button3'] != '' && $data['act_button3'] != '')
        {

            $num = 3;
            include 'inc/blocks/block_add_button.php';

        }
        // Кнопка 3
        

        // Кнопка 4
        if (!empty($data['name_button4']) && !empty($data['act_button4']) and $data['name_button4'] != '' && $data['act_button4'] != '')
        {

            $num = 4;
            include 'inc/blocks/block_add_button.php';

        }
        // Кнопка 4
        

        // Кнопка 5
        if (!empty($data['name_button5']) && !empty($data['act_button5']) and $data['name_button5'] != '' && $data['act_button5'] != '')
        {

            $num = 5;
            include 'inc/blocks/block_add_button.php';

        }
        // Кнопка 5
        
    }

}
catch(Exception $e)
{

    $response_array['status'] = false;
    $response_array['description'] = $e->getMessage();

    header('Content-type: application/json');
    echo json_encode($response_array);
}

