<?php
include 'inc/config.php';
include 'inc/functions.php';
include 'inc/session.php';

if (empty($user['login']) and empty($user['password']))
{
header('Location:'.$base_url.'logout');
exit;
}

session_write_close();
?>
<!DOCTYPE html>
<html lang="en">
    <head>
        <base href="<?=$base_url;?>">
        <meta charset="utf-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
        <meta name="description" content="" />
        <meta name="author" content="" />
        <title>Авто-рассылка</title>
        <link href="css/styles.css?2" rel="stylesheet" />
        <link href="https://cdn.datatables.net/1.10.20/css/dataTables.bootstrap4.min.css" rel="stylesheet" crossorigin="anonymous" />
        <script src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.11.2/js/all.min.js" crossorigin="anonymous"></script>
    </head>
    <body class="sb-nav-fixed">
<?php 
include 'inc/blocks/header.php';
?>
        <div id="layoutSidenav">
<?php
include 'inc/blocks/sidebar.php';
?>
            <div id="layoutSidenav_content">
                <main>
                    <div class="container-fluid">
                        <h3 class="my-4 ml-2">Авто-рассылка<button class="btn btn-primary px-4" style="float:right" data-toggle="modal" data-target="#newAutoSender">Новая рассылка</button></h3>
                        <div class="card mb-4">
                            <div class="card-body">
                                <div class="table-responsive">
                                    <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                                        <thead>
                                            <tr>
                                                <th class="font-weight-normal text-uppercase" style="width:15px;font-size: 13px">ID</th>
                                                <th class="font-weight-normal text-uppercase" style="font-size: 13px">Текст</th>
                                                <th class="font-weight-normal text-uppercase" style="font-size: 13px">Тип</th>
                                                <th class="font-weight-normal text-uppercase" style="font-size: 13px">Время выполнения</th>
                                                <th></th>

                                            </tr>
                                        </thead>
                                        <tbody>
<?php
$stmt = $pdo->prepare("SELECT * FROM senders WHERE project_id=:project_id ORDER BY id DESC");
$stmt->bindParam(':project_id', $project['id']);
$stmt->execute();
$result = $stmt->fetchAll(PDO::FETCH_ASSOC);

foreach ($result as $key => $value) {

$block_time = 'Через '.$value['time'].' '.wordForm($value['time'], array('минуту', 'минуты', 'минут'));

$act_bot[1] = '<i class="far fa-edit mx-3" style="cursor:pointer" title="Редактировать" onclick="editSender('.$value['id'].');" data-toggle="modal" data-target="#editSender"></i>';
$act_bot[2] = '<i class="far fa-trash-alt text-danger mx-3" style="cursor:pointer" title="Удалить" onclick="del_sender('.$value['id'].');"></i>';
?>
                                            <tr id="bot<?=$value['id'];?>">
                                                <td class="text-center"><?=$value['id'];?></td>
                                                <td><?=$value['message'];?></td>
                                                <td class="text-center">После вступления</td>
                                                <td class="text-center"><?=$block_time;?></td>
                                                <td class="text-center"><?=$act_bot[1];?><?=$act_bot[2];?></td>
                                               
                                            </tr>
<?php
}
?>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </main>
            </div>
        </div>
<?php
include 'inc/blocks/block.modals.php';
?>
        <script src="https://code.jquery.com/jquery-3.4.1.min.js" crossorigin="anonymous"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
        <script src="js/scripts.js"></script>
        <script src="https://cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js" crossorigin="anonymous"></script>
        <script src="https://cdn.datatables.net/1.10.20/js/dataTables.bootstrap4.min.js" crossorigin="anonymous"></script>
        <script src="assets/demo/datatables-demo.js"></script>
        <script src="js/simpleUpload.min.js?v=2"></script>
<?php
include 'inc/blocks/block.js.php';
?>
    </body>
</html>
