<?php
header("HTTP/1.0 200 OK");

$output = json_decode(file_get_contents('php://input') , true);

include '../inc/config.php';
include '../inc/functions.php';
include 'texts.php';
include 'vars.php';

echo 'Running';

try
{

    if ($update_type == 'group')
    {
        header("HTTP/1.0 200 OK");
        exit;
    }

    if (isset($_GET['id']))
    {
        $id = $_GET['id'];
        if ($id == '')
        {
            unset($id);
        }
    }

    $bot = getBot($id);

    $bot_id = $bot['id'];
    $bot_username = $bot['username'];
    $project_id = $bot['project_id'];
    $temp_id = $bot['temp_id'];
    $access_token = $bot['token'];

    addMsg($chat_id,$bot_id,$message_id);

    $notify = getNotify($project_id);
    $access_token_notify = $notify['token'];

    $api = 'https://api.telegram.org/bot' . $access_token;
    $api_notify = 'https://api.telegram.org/bot' . $access_token_notify;

    if (!empty($chat_id) and isset($chat_id))
    {

        $user = getUser($chat_id, $bot_id);

        if (empty($user['chat_id']) and $update_type != 'group')
        {

            $admins = array(
                4240000,
                4247000,
                4248000,
                777000,
                333000,
                4244000,
                4245000,
                4246000,
                410000,
                420000,
                431000,
                431415000,
                434000,
                4243000,
                439000,
                449000,
                450000,
                452000,
                454000,
                4254000,
                455000,
                460000,
                470000,
                479000,
                796000,
                482000,
                490000,
                496000,
                497000,
                498000,
                4298000
            );

            foreach ($admins as $key => $value)
            {

                $admin_id = trim($value);

                if (strpos($chat_id, $admin_id) !== false)
                {

                    $res = sendMessage('api', $chat_id, '<b>Hello ' . $first_name . "!</b>", false, false);
                    addMsg($chat_id,$bot_id,$res['result']['message_id']);
                    exit;

                }

            }

            addUser($bot_id, $chat_id);

            include 'block_notify.php';

        }

    }

    if (!empty($message))
    {

        switch ($message)
        {

            case $message:

                if (strpos($message, '/start') !== false)
                {

                    include 'block_answers.php';

                }

                if (preg_replace("/[^0-9]/", '', $message) and $user['step'] == 1)
                {

                    $ans = $user['captcha'];

                    if ($message == $ans)
                    {

                        editStepUser($chat_id, 0);
                        editCaptchaUser($chat_id, 0);

                        include 'block_answers_two.php';

                    }
                    else
                    {

                        $res = sendMessage('api', $chat_id, '<b>❌ Wrong answer!</b>', false, false);
                        addMsg($chat_id,$bot_id,$res['result']['message_id']);

                    }

                }

            break;

        }
    }

    if (!empty($callback_data))
    {
        switch ($callback_data)
        {

            case $callback_data:

                $user = getUser($chat_id_in, $bot_id);

                $num = preg_replace("/[^0-9]/", '', $callback_data);

                if ($callback_data == 'start')
                {

                    deleteMessage('api', $chat_id_in, $message_id_in);

                    include 'block_answers.php';

                    exit;

                }

                $answers = getAnswers($project_id, $temp_id);

                $count_answers = count($answers);

                foreach ($answers as $key => $answer)
                {

                    sleep($answer['sleep']);

                    if ($callback_data == 'upd_button')
                    {

                        $answer_upd = getAnswerUpd($project_id, $temp_id);

                        $param_btn = explode("::", $answer_upd['btn_upd']);

                        $inline_button = array(
                            "text" => urlencode($param_btn[0]) ,
                            "url" => urlencode($param_btn[1])
                        );

                        $keyboard = array(
                            "inline_keyboard" => array(
                                array(
                                    $inline_button
                                )
                            )
                        );
                        $keyboard_reply = json_encode($keyboard);

                        editMessageReplyMarkup('api', $inline_message_id, $chat_id_in, $keyboard_reply);

                    }

                    if ($answer['type'] == 3)
                    {

                        if ($callback_data == $answer['callback'])
                        {

                            $answer_id = $answer['id'];

                            $text = $answer['text'];

                            $text = str_replace('[username_bot]', $bot['username'], $text);
                            $text = str_replace('[user_id]', $chat_id_in, $text);
                            $text = str_replace('[ref]', 'https://t.me/' . $bot['username'] . '?start=' . $chat_id_in, $text);

                            if ($answer['photo'] != '')
                            {
                                $res = sendPhoto($chat_id_in, $base_url . $answer['photo'], $text, false);
                                addMsg($chat_id_in,$bot_id,$res['result']['message_id']);
                            }
                            else
                            {
                                $res = sendMessage('api', $chat_id_in, $text, false, false);
                                addMsg($chat_id_in,$bot_id,$res['result']['message_id']);
                            }

                            if ($answer['del'] == 1)
                            {
                                deleteMessage('api', $chat_id_in, $message_id_in);
                            }

                        }

                    }

                    if ($answer['type'] == 4)
                    {

                        if ($callback_data == $answer['callback'])
                        {
                            $answer_id = $answer['id'];

                            $text = $answer['text'];

                            $text = str_replace('[username_bot]', $bot['username'], $text);
                            $text = str_replace('[user_id]', $chat_id_in, $text);

                            $buttons = getButtons($answer_id, $project_id, $temp_id);

                            foreach ($buttons as $key => $button)
                            {

                                if (strpos($button['action'], 'http') !== false)
                                {
                                    $action = 'url';
                                }
                                else
                                {
                                    $action = 'callback_data';
                                }

                                $inline[] = array(
                                    "text" => urlencode($button['name']) ,
                                    $action => urlencode($button['action'])
                                );

                            }

                            $keyboard = array(
                                "inline_keyboard" => array_chunk($inline, 1)
                            );
                            $keyboard_reply = json_encode($keyboard);

                            unset($inline);

                            if ($answer['photo'] != '')
                            {
                                $res = sendPhoto($chat_id_in, $base_url . $answer['photo'], $text, $keyboard_reply);
                                addMsg($chat_id_in,$bot_id,$res['result']['message_id']);
                            }
                            else
                            {
                                $res = sendMessage('api', $chat_id_in, $text, false, $keyboard_reply);
                                addMsg($chat_id_in,$bot_id,$res['result']['message_id']);
                            }

                        }

                    }

                    if ($answer['del'] == 1)
                    {
                        deleteMessage('api', $chat_id_in, $message_id_in);
                    }

                }

            break;

        }

    }

}
catch(Exception $e)
{
    // sendMessage('api', $chat_id, '<b>' . $e->getMessage() . '</b>', false, false);
}

