<?php
include 'inc/config.php';
include 'inc/functions.php';
include 'inc/session.php';

if (empty($user['login']) and empty($user['password']))
{
header('Location:'.$base_url.'logout');
exit;
}

session_write_close();
?>
<!DOCTYPE html>
<html lang="en">
    <head>
    	<base href="<?=$base_url;?>">
        <meta charset="utf-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
        <meta name="description" content="" />
        <meta name="author" content="" />
        <title>Мои проекты</title>
        <link href="css/styles.css?2" rel="stylesheet" />
        <link href="https://cdn.datatables.net/1.10.20/css/dataTables.bootstrap4.min.css" rel="stylesheet" crossorigin="anonymous" />
        <script src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.11.2/js/all.min.js" crossorigin="anonymous"></script>
    </head>
    <body class="sb-nav-fixed">
<?php
include 'inc/blocks/header.php';
?>
        <div id="layoutSidenav">


<?php
if($project == true){
include 'inc/blocks/sidebar.php';
}
?>
            <div id="layoutSidenav_content" style="padding-left:0px;margin-left: 0px;">
                <main>
                    <div class="container">
                    <h3 class="my-4 ml-2">Мои проекты<button class="btn btn-primary px-4" style="float:right" id="create" data-toggle="modal" data-target="#createProject">Создать проект</button></h3>
                    <div class="row mt-5">
<?php
$stmt = $pdo->prepare("SELECT * FROM projects WHERE user_id=:user_id ORDER BY id DESC");
$stmt->bindParam(':user_id', $user_id);
$stmt->execute();
$result = $stmt->fetchAll(PDO::FETCH_ASSOC);

$count = $stmt->rowCount();

if($count == 0){
    echo '<div class="d-block mx-auto text-center my-5">У вас нет ни одного проекта.</div>';
}

foreach ($result as $key => $value) {

$count_bots = getCountBots($value['id']);
$count_users = getCountUsers($value['id']);
$count_new_users = getCountUsersNew($value['id']);

?>
  <div class="col-sm-4 mb-4" id="project<?=$value['id'];?>">
    <div class="card">
      <div class="card-body text-center">
        <h5 class="card-title"><?=$value['name'];?></h5>
        <hr class="my-3">
        <span class="mx-1"><i class="fas fa-robot" style="color: #666;"></i> <b><?=$count_bots;?></b></span> <span class="mx-1"><i class="fas fa-users" style="color: #666;"></i> <b><?=$count_users;?></b> <b class="text-success" style="font-size: 13px;position: relative;top: -5px;">+<?=$count_new_users;?></b></span>
        <hr class="my-3">
        <div class="d-block "><a href="project/<?=$value['hash'];?>/dashboard" class="btn btn-primary px-4 mb-3">Перейти в проект</a></div>
        <a  style="color:#000" href="#" class="ml-1" onclick="edit_project(<?=$value['id'];?>,'<?=$value['name'];?>');" data-toggle="modal" data-target="#editProject"><i class="far fa-edit" title="Редактировать"></i></a>
        <i class="far fa-trash-alt text-danger ml-3" onclick="del_project(<?=$value['id'];?>);" style="cursor: pointer" title="Удалить"></i>
        
      </div>
    </div>
  </div>
<?php
}
?>
</div>
                    </div>
                </main>
            </div>	
        </div>
<?php
include 'inc/blocks/block.modals.php';
?>
        <script src="https://code.jquery.com/jquery-3.4.1.min.js" crossorigin="anonymous"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
        <script src="js/scripts.js"></script>
        <script src="js/simpleUpload.min.js"></script>
<?php
if(!empty($_GET['do']) && $_GET['do'] == 'create'){
?>
<script type="text/javascript">
$('#create').click();
</script>
<?php
}
include 'inc/blocks/block.js.php';
?>
    </body>
</html>
