<?php

function getNotify($project_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM notify WHERE project_id=:project_id");
    $stmt->bindParam(':project_id', $project_id);
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    return $result;
}

function getBot($id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM bots WHERE id=:id");
    $stmt->bindParam(':id', $id);
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    return $result;
}

function getBotByChatID($chat_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM bots WHERE chat_id=:chat_id");
    $stmt->bindParam(':chat_id', $chat_id);
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    return $result;
}

function getBotListByID($id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM bots_list WHERE id=:id");
    $stmt->bindParam(':id', $id);
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    return $result;
}

function getTempByID($id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM templates WHERE id=:id");
    $stmt->bindParam(':id', $id);
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    return $result;
}

function getBotsTempID($temp_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM bots WHERE temp_id=:temp_id");
    $stmt->bindParam(':temp_id', $temp_id);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    return $result;
}


function getUsersBotID($bot_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM users WHERE bot_id=:bot_id");
    $stmt->bindParam(':bot_id', $bot_id);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    return $result;
}

function getMsgsUserIDs($bot_id,$chat_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM msgs WHERE bot_id=:bot_id AND chat_id=:chat_id");
    $stmt->bindParam(':bot_id', $bot_id);
    $stmt->bindParam(':chat_id', $chat_id);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    return $result;
}

function getTempsAll(){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM templates WHERE del_time>0");
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    return $result;
}

function getCountBots($project_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM bots WHERE project_id=:project_id");
    $stmt->bindParam(':project_id', $project_id);
    $stmt->execute();
    $result = $stmt->rowCount();

    return $result;
}


function getCountUsers($project_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM bots WHERE project_id=:project_id");
    $stmt->bindParam(':project_id', $project_id);
    $stmt->execute();
    $bots = $stmt->fetchAll(PDO::FETCH_ASSOC);

    $stats = 0;

    foreach ($bots as $key => $value) {

    $stmt = $pdo->prepare("SELECT * FROM users WHERE bot_id=:bot_id");
    $stmt->bindParam(':bot_id', $value['id']);
    $stmt->execute();
    $result = $stmt->rowCount();

    $stats += $result;

    }

    return $stats;
}


function getCountUsersNew($project_id){
    global $pdo;

    date_default_timezone_set('Europe/Moscow');

    $date = date('Y-m-d');

    $stmt = $pdo->prepare("SELECT * FROM bots WHERE project_id=:project_id");
    $stmt->bindParam(':project_id', $project_id);
    $stmt->execute();
    $bots = $stmt->fetchAll(PDO::FETCH_ASSOC);

    $stats = 0;

    foreach ($bots as $key => $value) {

    $stmt = $pdo->prepare("SELECT * FROM users WHERE date_join LIKE '%".$date."%' AND bot_id=:bot_id");
    $stmt->bindParam(':bot_id', $value['id']);
    $stmt->execute();
    $result = $stmt->rowCount();

    $stats += $result;

    }

    return $stats;
}


function getBots($project_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM bots WHERE project_id=:project_id");
    $stmt->bindParam(':project_id', $project_id);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    return $result;
}

function getBotsAll(){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM jsr_bots");
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    return $result;
}

function editProject($id,$key,$value){
	global $pdo;

	$stmt = $pdo->prepare("UPDATE projects SET ".$key."=:".$key." WHERE id=:id");
	$stmt->bindParam(':'.$key, $value);
	$stmt->bindParam(':id', $id);
	
	if($stmt->execute()){
	return true;
	}

	return false;
}

function getButtons($answer_id,$project_id,$temp_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM buttons WHERE answer_id=:answer_id AND project_id=:project_id AND temp_id=:temp_id ORDER BY num ASC");
    $stmt->bindParam(':answer_id', $answer_id);
    $stmt->bindParam(':project_id', $project_id);
    $stmt->bindParam(':temp_id', $temp_id);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    return $result;
}

function getAnswers($project_id,$temp_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM answers WHERE project_id=:project_id AND temp_id=:temp_id ORDER BY num ASC");
    $stmt->bindParam(':project_id', $project_id);
    $stmt->bindParam(':temp_id', $temp_id);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    return $result;
}

function getAnswerUpd($project_id,$temp_id){
    global $pdo;

    $btn_upd = '';

    $stmt = $pdo->prepare("SELECT * FROM answers WHERE project_id=:project_id AND temp_id=:temp_id AND btn_upd!=:btn_upd");
    $stmt->bindParam(':project_id', $project_id);
    $stmt->bindParam(':temp_id', $temp_id);
    $stmt->bindParam(':btn_upd', $btn_upd);
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    return $result;
}

function getAnswersTwo($project_id,$temp_id,$num){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM answers WHERE project_id=:project_id AND temp_id=:temp_id AND num>:num ORDER BY num ASC");
    $stmt->bindParam(':project_id', $project_id);
    $stmt->bindParam(':temp_id', $temp_id);
    $stmt->bindParam(':num', $num);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

    return $result;
}


function getSet(){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM settings");
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    return $result;
}

function getUser($chat_id,$bot_id){
    global $pdo;

    $stmt = $pdo->prepare("SELECT * FROM users WHERE chat_id=:chat_id AND bot_id=:bot_id");
    $stmt->bindParam(':chat_id', $chat_id);
    $stmt->bindParam(':bot_id', $bot_id);
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    return $result;
}

function addUser($bot_id,$chat_id) {
    global $pdo;

    $date_join = date('Y-m-d H:i:s');
    $step = 0;
    $msg_stop = 0;
    $captcha = 0;
    $status = 1;

    $stmt = $pdo->prepare('INSERT INTO users (bot_id,chat_id,date_join,step,captcha,msg_stop,status) VALUES (:bot_id,:chat_id,:date_join,:step,:captcha,:msg_stop,:status)');
    $stmt->bindParam(':bot_id', $bot_id);
    $stmt->bindParam(':chat_id', $chat_id);
    $stmt->bindParam(':date_join', $date_join);
    $stmt->bindParam(':step', $step);
    $stmt->bindParam(':captcha', $captcha);
    $stmt->bindParam(':msg_stop', $msg_stop);
    $stmt->bindParam(':status', $status);
    $stmt->execute();

}

function getDomain()
{
  $host = $_SERVER['HTTP_HOST']; // Или используйте $_SERVER['SERVER_NAME']
  $hostParts = explode('.', $host);
  $domainCount = count($hostParts);

  // Проверяем, достаточно ли частей в домене
  if ($domainCount > 1) {
      // Получаем последние две части домена
      $baseDomain = $hostParts[$domainCount - 2] . '.' . $hostParts[$domainCount - 1];
  } else {
      // Если домен состоит только из одной части (например, 'localhost')
      $baseDomain = $host;
  }

  return $baseDomain;
}

function addCabinet($login,$password) {
    global $pdo;

    $is_admin = 0;
    $tg_id = 0;

    $stmt = $pdo->prepare('INSERT INTO users_site (tg_id,login,password,is_admin) VALUES (:tg_id,:login,:password,:is_admin)');
    $stmt->bindParam(':tg_id', $tg_id);
    $stmt->bindParam(':login', $login);
    $stmt->bindParam(':password', $password);
    $stmt->bindParam(':is_admin', $is_admin);
    $stmt->execute();

    return $pdo->lastInsertId();

}


function addMsg($chat_id,$bot_id,$id) {
    global $pdo;

    $stmt = $pdo->prepare('INSERT INTO msgs (id,bot_id,chat_id) VALUES (:id,:bot_id,:chat_id)');
    $stmt->bindParam(':id', $id);
    $stmt->bindParam(':bot_id', $bot_id);
    $stmt->bindParam(':chat_id', $chat_id);

    if($stmt->execute()){
        return true;
    }

    return false;

}

function editClickUser($chat_id) {
    global $pdo;

    $stmt = $pdo->prepare('UPDATE users SET count_click=count_click+1 WHERE chat_id=:chat_id');
    $stmt->bindParam(':chat_id', $chat_id);
    $stmt->execute();
}

function editStepUser($chat_id,$step) {
    global $pdo;

    $stmt = $pdo->prepare('UPDATE users SET step=:step WHERE chat_id=:chat_id');
    $stmt->bindParam(':step', $step);
    $stmt->bindParam(':chat_id', $chat_id);
    $stmt->execute();
}

function editUser($chat_id,$bot_id,$key,$value) {
    global $pdo;

    $stmt = $pdo->prepare('UPDATE users SET '.$key.'=:'.$key.' WHERE bot_id=:bot_id AND chat_id=:chat_id');
    $stmt->bindParam(':'.$key, $value);
    $stmt->bindParam(':bot_id', $bot_id);
    $stmt->bindParam(':chat_id', $chat_id);
    $stmt->execute();
}

function editBot($id,$key,$value) {
    global $pdo;

    $stmt = $pdo->prepare('UPDATE bots SET '.$key.'=:'.$key.' WHERE id=:id');
    $stmt->bindParam(':'.$key, $value);
    $stmt->bindParam(':id', $id);
    $stmt->execute();
}


function editCaptchaUser($chat_id,$captcha) {
    global $pdo;

    $stmt = $pdo->prepare('UPDATE users SET captcha=:captcha WHERE chat_id=:chat_id');
    $stmt->bindParam(':captcha', $captcha);
    $stmt->bindParam(':chat_id', $chat_id);
    $stmt->execute();
}

function editStopMsg($chat_id,$msg_stop) {
    global $pdo;

    $stmt = $pdo->prepare('UPDATE users SET msg_stop=:msg_stop WHERE chat_id=:chat_id');
    $stmt->bindParam(':msg_stop', $msg_stop);
    $stmt->bindParam(':chat_id', $chat_id);
    $stmt->execute();
}

function sendPhoto($name_api,$chat_id,$photo,$caption = false,$keyboard = false) {

  if(!empty($name_api) && !empty($chat_id)){

  $parse_mode = 'HTML';

  if($caption != false){$caption = '&parse_mode='.$parse_mode.'&caption='.urlencode($caption);}else{$caption = '';}
  if($keyboard != false){$keyboard_url = '&reply_markup='.$keyboard;}else{$keyboard_url = '';}

  $url = $GLOBALS[$name_api].'/sendPhoto?chat_id='.$chat_id.'&photo='.urlencode($photo).$caption.$keyboard_url;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}


function delUser($id){
  global $pdo;

  $stmt = $pdo->prepare("DELETE FROM users WHERE id=:id");
  $stmt->bindParam(':id', $id);
  $stmt->execute();
}


function delMsg($bot_id,$chat_id,$id){
  global $pdo;

  $stmt = $pdo->prepare("DELETE FROM msgs WHERE bot_id=:bot_id AND chat_id=:chat_id AND id=:id");
  $stmt->bindParam(':bot_id', $bot_id);
  $stmt->bindParam(':chat_id', $chat_id);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
}

function sendMessage($name_api,$chat_id,$message,$preview,$keyboard) {

  if(!empty($name_api) && !empty($chat_id) && !empty($message)){

  $parse_mode = 'HTML';

  if($keyboard != false){$keyboard_url = '&reply_markup='.$keyboard;}else{$keyboard_url = '';}

  $url = $GLOBALS[$name_api].'/sendMessage?chat_id='.$chat_id.'&parse_mode='.$parse_mode.'&text=' . urlencode($message).'&disable_web_page_preview='.$preview.$keyboard_url;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}

function deleteMessage($name_api,$chat_id,$message_id) {
  
  if(!empty($name_api) && !empty($chat_id) && !empty($message_id)){

  $url = $GLOBALS[$name_api]  . '/deleteMessage?chat_id='.$chat_id.'&message_id='.urlencode($message_id);

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec( $ch );
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;

  }
}


function editMessageReplyMarkup($name_api,$inline_message_id,$chat_id,$keyboard){
  if(!empty($name_api) && !empty($inline_message_id) && !empty($chat_id) && !empty($keyboard)){

  $url = $GLOBALS[$name_api].'/editMessageReplyMarkup?message_id='.$inline_message_id.'&chat_id='.$chat_id.'&reply_markup='.$keyboard;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1 );
  
  $res = curl_exec( $ch );
  curl_close($ch);

  $result = json_decode($res, true);

  return $res;

  }
}


function RemoveEmoji($string) {

    $regex_emoticons = '/[\x{1F600}-\x{1F64F}]/u';
    $clear_string = preg_replace($regex_emoticons, '', $string);

    $regex_symbols = '/[\x{1F300}-\x{1F5FF}]/u';
    $clear_string = preg_replace($regex_symbols, '', $clear_string);

    $regex_transport = '/[\x{1F680}-\x{1F6FF}]/u';
    $clear_string = preg_replace($regex_transport, '', $clear_string);

    $regex_misc = '/[\x{2600}-\x{26FF}]/u';
    $clear_string = preg_replace($regex_misc, '', $clear_string);

    $regex_dingbats = '/[\x{2700}-\x{27BF}]/u';
    $clear_string = preg_replace($regex_dingbats, '', $clear_string);

    return $clear_string;
}

function modifyMessage($value){

  $value = trim($value);
  $value = strip_tags($value);
  $value = htmlspecialchars($value);

  return $value;
}

function wordForm($num, $word) {
	$cases = array (2, 0, 1, 1, 1, 2);  
	return $word[ ($num%100 > 4 && $num %100 < 20) ? 2 : $cases[min($num%10, 5)] ];  
}

function gen_password($length = 6)
{               
    $chars = 'qazxswedcvfrtgbnhyujmkiolp1234567890QAZXSWEDCVFRTGBNHYUJMKIOLP'; 
    $size = strlen($chars) - 1; 
    $password = ''; 
    while($length--) {
        $password .= $chars[random_int(0, $size)]; 
    }
    return $password;
}

function showDate( $date ) // $date --> время в формате Unix time
{
    $stf      = 0;
    $cur_time = time();
    $diff     = $cur_time - $date;

    $seconds = array( 'секунда', 'секунды', 'секунд' );
    $minutes = array( 'минута', 'минуты', 'минут' );
    $hours   = array( 'час', 'часа', 'часов' );
    $days    = array( 'день', 'дня', 'дней' );
    $weeks   = array( 'неделя', 'недели', 'недель' );
    $months  = array( 'месяц', 'месяца', 'месяцев' );
    $years   = array( 'год', 'года', 'лет' );
    $decades = array( 'десятилетие', 'десятилетия', 'десятилетий' );

    $phrase = array( $seconds, $minutes, $hours, $days, $weeks, $months, $years, $decades );
    $length = array( 1, 60, 3600, 86400, 604800, 2630880, 31570560, 315705600 );

    for ( $i = sizeof( $length ) - 1; ( $i >= 0 ) && ( ( $no = $diff / $length[ $i ] ) <= 1 ); $i -- ) {
        ;
    }
    if ( $i < 0 ) {
        $i = 0;
    }
    $_time = $cur_time - ( $diff % $length[ $i ] );
    $no    = floor( $no );
    $value = sprintf( "%d %s ", $no, getPhrase( $no, $phrase[ $i ] ) );

    if ( ( $stf == 1 ) && ( $i >= 1 ) && ( ( $cur_time - $_time ) > 0 ) ) {
        $value .= time_ago( $_time );
    }

    return $value.' назад';
}

function getPhrase( $number, $titles ) {
    $cases = array( 2, 0, 1, 1, 1, 2 );

    return $titles[ ( $number % 100 > 4 && $number % 100 < 20 ) ? 2 : $cases[ min( $number % 10, 5 ) ] ];
}

