<?php
include 'inc/config.php';
include 'inc/functions.php';
include 'inc/session.php';

if (empty($user['login']) and empty($user['password']))
{
header('Location:'.$base_url.'logout');
exit;
}

session_write_close();
?>
<!DOCTYPE html>
<html lang="en">
    <head>
        <base href="<?=$base_url;?>">
        <meta charset="utf-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
        <meta name="description" content="" />
        <meta name="author" content="" />
        <title>Шаблоны</title>
        <link href="css/styles.css?2" rel="stylesheet" />
        <link href="https://cdn.datatables.net/1.10.20/css/dataTables.bootstrap4.min.css" rel="stylesheet" crossorigin="anonymous" />
        <script src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.11.2/js/all.min.js" crossorigin="anonymous"></script>
    </head>
    <body class="sb-nav-fixed">
<?php 
include 'inc/blocks/header.php';
?>
        <div id="layoutSidenav">
<?php
include 'inc/blocks/sidebar.php';
?>
            <div id="layoutSidenav_content">
                <main>
                    <div class="container-fluid">
                        <h3 class="my-4 ml-2">Шаблоны<button class="btn btn-primary px-4" style="float:right" data-toggle="modal" data-target="#createTemplate">Создать шаблон</button></h3>
                        <div class="row mt-5">
<?php
$stmt = $pdo->prepare("SELECT * FROM templates WHERE project_id=:project_id ORDER BY date_edit DESC");
$stmt->bindParam(':project_id', $project['id']);
$stmt->execute();
$result = $stmt->fetchAll(PDO::FETCH_ASSOC);

$count = $stmt->rowCount();

if($count == 0){
	echo '<div class="d-block mx-auto text-center my-5">В этом проекте пока нет ни одного шаблона.</div>';
}

foreach ($result as $key => $value) {
?>
  <div class="col-sm-4 mb-4" id="template<?=$value['id'];?>">
    <div class="card">
      <div class="card-body">
        <h5 class="card-title"><?=$value['name'];?></h5>
        <hr>
        <a href="project/<?=$hash_project;?>/constructor/<?=$value['id'];?>" style="color:#000" class="ml-1"><i class="far fa-edit" title="Редактировать"></i></a>
        <i class="far fa-trash-alt text-danger ml-3" onclick="del_template(<?=$value['id'];?>);" style="cursor: pointer" title="Удалить"></i>
      </div>
    </div>
  </div>
<?php
}
?>
</div>
                    </div>
                </main>
            </div>
        </div>

<?php
include 'inc/blocks/block.modals.php';
?>
        <script src="https://code.jquery.com/jquery-3.4.1.min.js" crossorigin="anonymous"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
        <script src="js/scripts.js"></script>
        <script src="https://cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js" crossorigin="anonymous"></script>
        <script src="https://cdn.datatables.net/1.10.20/js/dataTables.bootstrap4.min.js" crossorigin="anonymous"></script>
        <script src="assets/demo/datatables-demo.js"></script>
        <script src="js/simpleUpload.min.js"></script>
<?php
include 'inc/blocks/block.js.php';
?>
    </body>
</html>
