<?php
function getSuccessCountMembersByBundle($bid,$rid){
  global $pdo;

  $status = 1;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."members WHERE bid=:bid AND rid=:rid AND status=:status");
  $stmt->bindParam(':bid', $bid);
  $stmt->bindParam(':rid', $rid);
  $stmt->bindParam(':status', $status);
  $stmt->execute();
  $result = $stmt->rowCount();

  return $result;
}

function getDomain()
{
  $host = $_SERVER['HTTP_HOST']; // Или используйте $_SERVER['SERVER_NAME']
  $hostParts = explode('.', $host);
  $domainCount = count($hostParts);

  // Проверяем, достаточно ли частей в домене
  if ($domainCount > 1) {
      // Получаем последние две части домена
      $baseDomain = $hostParts[$domainCount - 2] . '.' . $hostParts[$domainCount - 1];
  } else {
      // Если домен состоит только из одной части (например, 'localhost')
      $baseDomain = $host;
  }

  return $baseDomain;
}

function getErrorsCountMembersByBundle($bid,$rid){
  global $pdo;

  $status = 0;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."members WHERE bid=:bid AND rid=:rid AND status=:status");
  $stmt->bindParam(':bid', $bid);
  $stmt->bindParam(':rid', $rid);
  $stmt->bindParam(':status', $status);
  $stmt->execute();
  $result = $stmt->rowCount();

  return $result;
}

function getResourceByID($id){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."resources WHERE id=:id");
  $stmt->bindParam(':id', $id);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getBotByID($id){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bots WHERE id=:id");
  $stmt->bindParam(':id', $id);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getBotSessionByID($uid,$id){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bots WHERE uid=:uid AND id=:id");
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getBotByToken($token){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bots WHERE token=:token");
  $stmt->bindParam(':token', $token);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getBundleSessionByID($uid,$id){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bundles WHERE uid=:uid AND id=:id");
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getSenderSessionByID($uid,$id){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."senders WHERE uid=:uid AND id=:id");
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getMyBotsAll($uid){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bots WHERE uid=:uid");
  $stmt->bindParam(':uid', $uid);
  $stmt->execute();
  $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

  return $result;
}

function getMyResourcesAll($uid){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."resources WHERE uid=:uid");
  $stmt->bindParam(':uid', $uid);
  $stmt->execute();
  $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

  return $result;
}

function getMyBundlesAll($uid){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bundles WHERE uid=:uid");
  $stmt->bindParam(':uid', $uid);
  $stmt->execute();
  $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

  return $result;
}

function getBundleByID($id){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bundles WHERE id=:id");
  $stmt->bindParam(':id', $id);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getBundleByBidAndRid($bid,$rid){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bundles WHERE bid=:bid AND rid=:rid");
  $stmt->bindParam(':bid', $bid);
  $stmt->bindParam(':rid', $rid);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getBundleByRid($rid){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bundles WHERE rid=:rid");
  $stmt->bindParam(':rid', $rid);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getBundleByBid($bid){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."bundles WHERE bid=:bid");
  $stmt->bindParam(':bid', $bid);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getSenderByType($bind_id,$type){
  global $pdo;

  $status = 1;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."senders WHERE bind_id=:bind_id AND type=:type AND status=:status");
  $stmt->bindParam(':bind_id', $bind_id);
  $stmt->bindParam(':type', $type);
  $stmt->bindParam(':status', $status);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getSenderByID($id){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."senders WHERE id=:id");
  $stmt->bindParam(':id', $id);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getSendersByBindID($bind_id,$type){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."senders WHERE bind_id=:bind_id AND type=:type");
  $stmt->bindParam(':bind_id', $bind_id);
  $stmt->bindParam(':type', $type);
  $stmt->execute();
  $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

  return $result;
}

function getSendersCron($type,$status,$send_at){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."senders WHERE type!=:type AND status=:status AND send_at=:send_at");
  $stmt->bindParam(':type', $type);
  $stmt->bindParam(':status', $status);
  $stmt->bindParam(':send_at', $send_at);
  $stmt->execute();
  $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

  return $result;
}

function getAdmin($tg_id){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM users_site WHERE tg_id=:tg_id");
  $stmt->bindParam(':tg_id', $tg_id);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getAdminByLP($login,$password){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM users_site WHERE login=:login AND password=:password");
  $stmt->bindParam(':login', $login);
  $stmt->bindParam(':password', $password);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getAdminByLogin($login){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM users_site WHERE login=:login");
  $stmt->bindParam(':login', $login);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getMember($chat_id){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."members WHERE chat_id=:chat_id");
  $stmt->bindParam(':chat_id', $chat_id);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getMemberCron($chat_id,$bid,$rid){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."members WHERE chat_id=:chat_id AND bid=:bid AND rid=:rid");
  $stmt->bindParam(':chat_id', $chat_id);
  $stmt->bindParam(':bid', $bid);
  $stmt->bindParam(':rid', $rid);
  $stmt->execute();
  $result = $stmt->fetch(PDO::FETCH_ASSOC);

  return $result;
}

function getMembersCron($bid,$rid){
  global $pdo;

  $stmt = $pdo->prepare("SELECT * FROM ".$GLOBALS['db_prefix']."members WHERE bid=:bid AND rid=:rid");
  $stmt->bindParam(':bid', $bid);
  $stmt->bindParam(':rid', $rid);
  $stmt->execute();
  $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

  return $result;
}

function editResource($id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'resources SET '.$key.'=:'.$key.' WHERE id=:id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
}

function editSender($id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'senders SET '.$key.'=:'.$key.' WHERE id=:id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
}

function editSenderSessionByID($uid,$id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'senders SET '.$key.'=:'.$key.' WHERE uid=:uid AND id=:id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
}

function editBundleSessionByID($uid,$id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'bundles SET '.$key.'=:'.$key.' WHERE uid=:uid AND id=:id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
}

function editBotSessionByID($uid,$id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'bots SET '.$key.'=:'.$key.' WHERE uid=:uid AND id=:id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
}

function editSenderPlus($id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'senders SET '.$key.'='.$key.'+:'.$key.' WHERE id=:id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
}

function editSenderMinus($id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'senders SET '.$key.'='.$key.'-:'.$key.' WHERE id=:id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':id', $id);
  $stmt->execute();
}

function editAdminByLogin($login,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE users_site SET '.$key.'=:'.$key.' WHERE login=:login');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':login', $login);
  $stmt->execute();
}

function editMember($chat_id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'members SET '.$key.'=:'.$key.' WHERE chat_id=:chat_id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':chat_id', $chat_id);
  $stmt->execute();
}

function editMemberPlus($chat_id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'members SET '.$key.'='.$key.'+:'.$key.' WHERE chat_id=:chat_id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':chat_id', $chat_id);
  $stmt->execute();
}

function editMemberMinus($chat_id,$key,$value){
  global $pdo;

  $stmt = $pdo->prepare('UPDATE '.$GLOBALS['db_prefix'].'members SET '.$key.'='.$key.'-:'.$key.' WHERE chat_id=:chat_id');
  $stmt->bindParam(':'.$key, $value);
  $stmt->bindParam(':chat_id', $chat_id);
  $stmt->execute();
}


function addMember($chat_id,$bid,$rid){
  global $pdo;

  $status = 1;
  $joined_at = strtotime('NOW');

  $stmt = $pdo->prepare('INSERT INTO '.$GLOBALS['db_prefix'].'members (chat_id,bid,rid,joined_at,status) VALUES (:chat_id,:bid,:rid,:joined_at,:status)');
  $stmt->bindParam(':chat_id', $chat_id);
  $stmt->bindParam(':bid', $bid);
  $stmt->bindParam(':rid', $rid);
  $stmt->bindParam(':joined_at', $joined_at);
  $stmt->bindParam(':status', $status);

  if($stmt->execute()){
    return true;
  }

  return false;
}

function newSender($uid,$bind_id,$text,$is_preview,$media,$buttons,$type){
  global $pdo;

  $status = 1;
  $send_at = strtotime(date('Y-m-d H:i').'+1 minutes');
  $success = 0;
  $errors = 0;

  $stmt = $pdo->prepare('INSERT INTO '.$GLOBALS['db_prefix'].'senders (uid,bind_id,text,is_preview,media,buttons,success,errors,type,send_at,status) VALUES (:uid,:bind_id,:text,:is_preview,:media,:buttons,:success,:errors,:type,:send_at,:status)');
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':bind_id', $bind_id);
  $stmt->bindParam(':text', $text);
  $stmt->bindParam(':is_preview', $is_preview);
  $stmt->bindParam(':media', $media);
  $stmt->bindParam(':buttons', $buttons);
  $stmt->bindParam(':success', $success);
  $stmt->bindParam(':errors', $errors);
  $stmt->bindParam(':type', $type);
  $stmt->bindParam(':send_at', $send_at);
  $stmt->bindParam(':status', $status);

  if($stmt->execute()){
    return true;
  }

  return false;
}

function addBot($uid,$title,$username,$token){
  global $pdo;

  $id = explode(':',$token)[0];

  $stmt = $pdo->prepare('INSERT INTO '.$GLOBALS['db_prefix'].'bots (id,uid,title,username,token) VALUES (:id,:uid,:title,:username,:token)');
  $stmt->bindParam(':id', $id);
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':title', $title);
  $stmt->bindParam(':username', $username);
  $stmt->bindParam(':token', $token);

  if($stmt->execute()){
    return true;
  }

  return false;
}

function addResource($uid,$id,$title){
  global $pdo;

  $invite_link = '';

  $stmt = $pdo->prepare('INSERT INTO '.$GLOBALS['db_prefix'].'resources (id,uid,title,invite_link) VALUES (:id,:uid,:title,:invite_link)');
  $stmt->bindParam(':id', $id);
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':title', $title);
  $stmt->bindParam(':invite_link', $invite_link);

  if($stmt->execute()){
    return true;
  }

  return false;
}

function addBundle($uid,$bid,$rid){
  global $pdo;

  $stmt = $pdo->prepare('INSERT INTO '.$GLOBALS['db_prefix'].'bundles (uid,bid,rid) VALUES (:uid,:bid,:rid)');
  $stmt->bindParam(':uid', $uid);
  $stmt->bindParam(':bid', $bid);
  $stmt->bindParam(':rid', $rid);

  if($stmt->execute()){
    return true;
  }

  return false;
}

function deleteBotByID($uid,$id){
    global $pdo;
    $stmt = $pdo->prepare('DELETE FROM '.$GLOBALS['db_prefix'].'bots WHERE uid=:uid AND id=:id');
    $uid = intval($uid);
    $id = intval($id);
    $stmt->bindParam(':uid', $uid);
    $stmt->bindParam(':id', $id);
    if ($stmt->execute())
    {
        return true;
    }
    return false;
}

function deleteResourceByID($uid,$id){
    global $pdo;
    $stmt = $pdo->prepare('DELETE FROM '.$GLOBALS['db_prefix'].'resources WHERE uid=:uid AND id=:id');
    $uid = intval($uid);
    $id = intval($id);
    $stmt->bindParam(':uid', $uid);
    $stmt->bindParam(':id', $id);
    if ($stmt->execute())
    {
        return true;
    }
    return false;
}

function deleteBundleByID($uid,$id){
    global $pdo;
    $stmt = $pdo->prepare('DELETE FROM '.$GLOBALS['db_prefix'].'bundles WHERE uid=:uid AND id=:id');
    $uid = intval($uid);
    $id = intval($id);
    $stmt->bindParam(':uid', $uid);
    $stmt->bindParam(':id', $id);
    if ($stmt->execute())
    {
        return true;
    }
    return false;
}

function deleteSenderByID($uid,$id){
    global $pdo;
    $stmt = $pdo->prepare('DELETE FROM '.$GLOBALS['db_prefix'].'senders WHERE uid=:uid AND id=:id');
    $uid = intval($uid);
    $id = intval($id);
    $stmt->bindParam(':uid', $uid);
    $stmt->bindParam(':id', $id);
    if ($stmt->execute())
    {
        return true;
    }
    return false;
}

function deleteSendersByBindID($uid,$bind_id){
    global $pdo;
    $stmt = $pdo->prepare('DELETE FROM '.$GLOBALS['db_prefix'].'senders WHERE uid=:uid AND bind_id=:bind_id');
    $uid = intval($uid);
    $bind_id = intval($bind_id);
    $stmt->bindParam(':uid', $uid);
    $stmt->bindParam(':bind_id', $bind_id);
    if ($stmt->execute())
    {
        return true;
    }
    return false;
}

function modifyMessage($value){

  $value = trim($value);
  $value = strip_tags($value);
  $value = htmlspecialchars($value);

  return $value;
}

function sendMessage($name_api,$chat_id,$message,$preview,$keyboard) {

  if(!empty($name_api) && !empty($chat_id) && !empty($message)){

  $parse_mode = 'HTML';

  if($keyboard != false){$keyboard_url = '&reply_markup='.$keyboard;}else{$keyboard_url = '';}

  $url = $GLOBALS[$name_api].'/sendMessage?chat_id='.$chat_id.'&parse_mode='.$parse_mode.'&text=' . urlencode($message).'&disable_web_page_preview='.$preview.$keyboard_url;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}

function forwardMessage($name_api,$chat_id,$from_chat_id,$message_id) {

  if(!empty($name_api) && !empty($chat_id) && !empty($from_chat_id) && !empty($message_id)){


  $url = $GLOBALS[$name_api].'/forwardMessage?chat_id='.$chat_id.'&from_chat_id='.$from_chat_id.'&message_id='.$message_id;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}


function sendDice($name_api,$chat_id,$emoji,$keyboard) {

  if(!empty($name_api) && !empty($chat_id) && !empty($emoji)){

  $parse_mode = 'HTML';

  if($keyboard != false){$keyboard_url = '&reply_markup='.$keyboard;}else{$keyboard_url = '';}

  $url = $GLOBALS[$name_api].'/sendDice?chat_id='.$chat_id.'&emoji='.$emoji.$keyboard_url;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}

function editMessageReplyMarkup($name_api, $inline_message_id, $chat_id, $keyboard)
{
    if (!empty($name_api) && !empty($inline_message_id) && !empty($chat_id) && !empty($keyboard))
    {
        $url = $GLOBALS[$name_api] . '/editMessageReplyMarkup?message_id=' . $inline_message_id . '&chat_id=' . $chat_id . '&reply_markup=' . $keyboard;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $res = curl_exec($ch);
        curl_close($ch);
        $result = json_decode($res, true);

        return $res;
    }
}
function editMessageText($name_api, $inline_message_id, $chat_id, $message, $preview, $keyboard)
{
    if (!empty($chat_id))
    {
        $parse_mode = 'HTML';
        $url = $GLOBALS[$name_api] . '/editMessageText?message_id=' . $inline_message_id . '&text=' . urlencode($message) . '&parse_mode=' . $parse_mode . '&chat_id=' . $chat_id . '&reply_markup=' . $keyboard . '&disable_web_page_preview=' . $preview;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $res = curl_exec($ch);
        curl_close($ch);
        $result = json_decode($res, true);

        return $result;
    }
}


function deleteMessage($name_api,$chat_id,$message_id) {
  
  if(!empty($name_api) && !empty($chat_id) && !empty($message_id)){

  $url = $GLOBALS[$name_api]  . '/deleteMessage?chat_id='.$chat_id.'&message_id='.urlencode($message_id);

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec( $ch );
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;

  }
}


function restrictChatMember($name_api,$chat_id,$user_id,$permissions) {

  if(!empty($name_api) && !empty($chat_id) && !empty($user_id) && !empty($permissions)){

  $url = $GLOBALS[$name_api].'/restrictChatMember?chat_id='.$chat_id.'&user_id='.$user_id.'&permissions='.json_encode($permissions);

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}


function approveChatJoinRequest($name_api,$chat_id,$user_id) {

  if(!empty($name_api) && !empty($chat_id) && !empty($user_id)){

  $url = $GLOBALS[$name_api].'/approveChatJoinRequest?chat_id='.$chat_id.'&user_id='.$user_id;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}

function createChatInviteLink($name_api,$chat_id,$creates_join_request) {

  if(!empty($name_api) && !empty($chat_id)){

  $url = $GLOBALS[$name_api].'/createChatInviteLink?chat_id=-100'.$chat_id.'&creates_join_request='.$creates_join_request;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL,$url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1 );
  $res = curl_exec( $ch );
  curl_close($ch);
  $result = json_decode($res, true);

  return $result;

  }

}

function getMemberJoined($name_api,$chat_id,$user_id) {

  if(!empty($name_api) && !empty($chat_id)){

  $url = $GLOBALS[$name_api].'/getChatMember?chat_id='.$chat_id.'&user_id='.$user_id;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL,$url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1 );
  $res = curl_exec( $ch );
  curl_close($ch);
  $result = json_decode($res, true);

  return $result;

  }

}

function getMe($name_api) {

  if(!empty($name_api)){

  $url = $GLOBALS[$name_api].'/getMe';

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL,$url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1 );
  $res = curl_exec( $ch );
  curl_close($ch);
  $result = json_decode($res, true);

  return $result;

  }

}

function setWebhook($name_api,$token) {

  if(!empty($name_api)){

  $url = $GLOBALS[$name_api].'/setWebhook?url=https://'.$_SERVER['SERVER_NAME'].'/bot/'.$token;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL,$url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1 );
  $res = curl_exec( $ch );
  curl_close($ch);
  $result = json_decode($res, true);

  return $result;

  }

}



function sendSticker($name_api,$chat_id,$sticker) {

  if(!empty($name_api) && !empty($chat_id)){

  $parse_mode = 'HTML';

  $url = $GLOBALS[$name_api].'/sendSticker?chat_id='.$chat_id.'&sticker='.$sticker;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}

function sendVideo($name_api,$chat_id,$video,$caption = false,$keyboard = false) {

  if(!empty($name_api) && !empty($chat_id)){

  $parse_mode = 'HTML';

  if($caption != false){$caption = '&parse_mode='.$parse_mode.'&caption='.urlencode($caption);}else{$caption = '';}
  if($keyboard != false){$keyboard_url = '&reply_markup='.$keyboard;}else{$keyboard_url = '';}

  $url = $GLOBALS[$name_api].'/sendVideo?chat_id='.$chat_id.'&video='.urlencode($video).$caption.$keyboard_url;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}

function sendPhoto($name_api,$chat_id,$photo,$caption = false,$preview = false,$keyboard = false) {

  if(!empty($name_api) && !empty($chat_id)){

  $parse_mode = 'HTML';

  if($caption != false){$caption = '&parse_mode='.$parse_mode.'&caption='.urlencode($caption);}else{$caption = '';}
  if($keyboard != false){$keyboard_url = '&reply_markup='.$keyboard;}else{$keyboard_url = '';}

  $url = $GLOBALS[$name_api].'/sendPhoto?chat_id='.$chat_id.'&photo='.urlencode($photo).$caption.'&disable_web_page_preview='.$preview.$keyboard_url;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}

function sendVoice($name_api,$chat_id,$voice,$caption = false,$keyboard = false) {

  if(!empty($name_api) && !empty($chat_id)){

  $parse_mode = 'HTML';

  if($caption != false){$caption = '&parse_mode='.$parse_mode.'&caption='.urlencode($caption);}else{$caption = '';}
  if($keyboard != false){$keyboard_url = '&reply_markup='.$keyboard;}else{$keyboard_url = '';}

  $url = $GLOBALS[$name_api].'/sendVoice?chat_id='.$chat_id.'&voice='.urlencode($voice).$caption.$keyboard_url;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}


function sendChatAction($name_api,$chat_id,$action) {

  if(!empty($name_api) && !empty($chat_id)){

  $url = $GLOBALS[$name_api].'/sendChatAction?chat_id='.$chat_id.'&action='.$action;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  $res = curl_exec($ch);
  curl_close($ch);

  $result = json_decode($res, true);

  return $result;
  }

}


function sendAnswerCallbackQuery($name_api,$callback_query_id,$text,$show_alert){

  $url = $GLOBALS[$name_api] ."/answerCallbackQuery?callback_query_id=".$callback_query_id."&text=".$text."&show_alert=".$show_alert;

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1 );
  $res = curl_exec( $ch );
  curl_close($ch);

  return $res;
}

function formatNum($value){
  return number_format($value, 2, '.', '');
}