<!DOCTYPE html>
<html lang="en">

<head>
	<meta charset="utf-8" />
	<meta http-equiv="X-UA-Compatible" content="IE=edge" />
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
	<meta name="description" content="" />
	<meta name="author" content="" />
	<title>Боты</title>
	<link href="/css/style.css?10" rel="stylesheet" />
	<link href="https://cdn.datatables.net/1.10.20/css/dataTables.bootstrap4.min.css" rel="stylesheet" crossorigin="anonymous" />
	<script src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.11.2/js/all.min.js" crossorigin="anonymous"></script>
</head>

<body class="sb-nav-fixed">
	<?php include '_blocks/header.php'; ?>
		<div id="layoutSidenav">
			<?php include '_blocks/sidebar.php'; ?>
				<div id="layoutSidenav_content">
					<main>
						<div class="container-fluid">
							<div class="d-flex align-items-center">
								<h3 class="my-4 ml-2 mr-auto">Боты</h3>
								<div>
									<button class="btn btn-primary px-4" style="float:right" data-toggle="modal" data-target="#newItem">Добавить</button>
								</div>
							</div>
							<div class="card mb-4">
								<div class="card-body">
									<div class="table-responsive">
										<table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
											<thead>
												<tr>
													<th class="font-weight-normal text-uppercase" style="width:15px;font-size: 13px">ID</th>
													<th class="font-weight-normal text-uppercase" style="font-size: 13px">Название</th>
													<th class="font-weight-normal text-uppercase" style="width:15px;font-size: 13px"></th>
													<th class="font-weight-normal text-uppercase" style="width:15px;font-size: 13px"></th>
													<th class="font-weight-normal text-uppercase" style="width:15px;font-size: 13px"></th>
												</tr>
											</thead>
										</table>
									</div>
								</div>
							</div>
						</div>
					</main>
				</div>
		</div>
		<div class="modal fade" id="newItem" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
			<div class="modal-dialog" role="document">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title mx-3" id="exampleModalLabel">Добавить бота</h5>
						<button class="close" type="button" data-dismiss="modal" aria-label="Close"> <span aria-hidden="true">×</span> </button>
					</div>
					<form id="form" class="modal-body">
						<div class="form-group mx-3">
							<label for="token">Токен бота</label>
							<input type="text" class="form-control" id="token" name="token" placeholder="Вставьте токен бота"> </div>
					</form>
					<div class="modal-footer">
						<button class="btn btn-secondary px-4" type="button" data-dismiss="modal">Отмена</button>
						<button class="btn btn-primary px-4" onclick="addBot();">Добавить</button>
					</div>
				</div>
			</div>
		</div>
		<div class="modal fade" id="editItem" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
			<div class="modal-dialog" role="document">
				<div class="modal-content">
					<div class="modal-header">
						<h5 class="modal-title mx-3" id="exampleModalLabel">Редактировать бота</h5>
						<button class="close" type="button" data-dismiss="modal" aria-label="Close"> <span aria-hidden="true">×</span> </button>
					</div>
					<form id="form" class="modal-body">
						<div class="form-group mx-3">
							<label for="token">Токен бота</label>
							<input type="text" class="form-control" id="token" name="token" placeholder="Вставьте токен бота"> </div>
					</form>
					<div class="modal-footer">
						<button class="btn btn-secondary px-4" type="button" data-dismiss="modal">Отмена</button>
						<button class="btn btn-primary px-4 bt-save">Сохранить</button>
					</div>
				</div>
			</div>
		</div>
		<script src="https://code.jquery.com/jquery-3.4.1.min.js" crossorigin="anonymous"></script>
		<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>
		<script src="https://cdn.datatables.net/1.10.20/js/jquery.dataTables.min.js" crossorigin="anonymous"></script>
		<script src="https://cdn.datatables.net/1.10.20/js/dataTables.bootstrap4.min.js" crossorigin="anonymous"></script>
		<script type="text/javascript">
		$('#item_bots').addClass('active');

		$('#editItem').on('show.bs.modal', function(event) {
			var button = $(event.relatedTarget);
			var id = button.data('id');
			$.post('/api/bot_info', {
				id: id
			}, function(data) {
				if(data.status == true) {
					$('#editItem #token').val(data.result.token);
					$('#editItem .bt-save').attr('onclick', 'saveBot(' + id + ')');
				} else if(data.status == false) {
					alert('Ошибка! Не удалось получить информацию');
				}
			});
		});
		$('#dataTable').DataTable({
			'processing': true,
			'serverSide': true,
			'serverMethod': 'post',
			'destroy': true,
			'searching': true,
			"ajax": "api.bots.php",
			// "order": [[ 0, "desc" ]],
			"language": {
				"processing": "Пожалуйста подождите..",
				"emptyTable": "У вас нет ни одного бота",
				"info": "Страница _PAGE_ из _PAGES_",
				"infoEmpty": "Показано 0 из 0",
				"lengthMenu": "_MENU_",
				"zeroRecords": "По запросу не найдено ни одного бота",
				"search": "",
				"searchPlaceholder": "Поиск по таблице",
				"paginate": {
					"first": "Первая",
					"last": "Последняя",
					"next": "Следующая",
					"previous": "Предыдущая"
				}
			}
		});

		function addBot() {
			var data = $('#newItem #form').serializeFormJSON();
			$.post('/api/add_bot', {
				data: data
			}, function(data) {
				if(data.status == true) {
					$('#newItem').modal('hide');
					$('#dataTable').DataTable().ajax.reload();
				} else if(data.status == false) {
					alert(data.description);
				}
			});
		}

		function saveBot(id) {
			var data = $('#editItem #form').serializeFormJSON();
			$.post('/api/save_bot', {
				data: data,
				id: id
			}, function(data) {
				if(data.status == true) {
					$('#editItem').modal('hide');
					$('#dataTable').DataTable().ajax.reload();
				} else if(data.status == false) {
					alert(data.description);
				}
			});
		}

		function copyToClipboard(element) {
			var $temp = $("<input>");
			$("body").append($temp);
			$temp.val($(element).attr('data-link')).select();
			document.execCommand("copy");
			$temp.remove();
		}

		function deleteItem(id) {

			let del = confirm("Точно хотите удалить бота?\r\n\r\nПри удалении бота будут удалены все связки и рассылки связанные с ним.");

			if(del){
			$.post('/api/delete_bot', {
				id: id
			}, function(data) {
				if(data.status == true) {
					$('#dataTable').DataTable().ajax.reload();
				} else if(data.status == false) {
					alert(data.description);
				}
			});
			}
		}
		(function($) {
			$.fn.serializeFormJSON = function() {
				var o = {};
				var a = this.serializeArray();
				$.each(a, function() {
					if(o[this.name]) {
						if(!o[this.name].push) {
							o[this.name] = [o[this.name]];
						}
						o[this.name].push(this.value || '');
					} else {
						o[this.name] = this.value || '';
					}
				});
				return o;
			};
		})(jQuery);
		</script>
</body>

</html>